/**
 * vim: set ts=4 :
 * =============================================================================
 * MegaHAL Extension SourcePawn Include
 * Copyright (C) 2011 Afronanny.  All rights reserved.
 * =============================================================================
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, version 3.0, as published by the
 * Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 */

typedef MHReply = function void (const char[] reply);


/**
 * MH_Learn
 * 
 * Essentially the same as MH_DoReply
 * except MH_Learn will not reply to the input
 * 
 * @param input				The string that MegaHAL will store in its brain
 * 
 * @noreturn
 */
native void MH_Learn(const char[] input);


/**
 * MH_DoReply
 * 
 * Takes a string and generates 
 *
 * 
 * @param input				The string that MegaHAL will generate a reply to
 * 
 * @param ReplyFunction		The function that will be called once MegaHAL 
 * 							generates a reply
 * @noreturn
 */
native void MH_DoReply(const char[] input, MHReply ReplyFunction);

/**
 * Do not edit below this line!
 */
public Extension:__ext_megahal = 
{
	name = "MegaHAL Ext",
	file = "megahal.ext",
#if defined AUTOLOAD_EXTENSIONS
	autoload = 1,
#else
	autoload = 0,
#endif
#if defined REQUIRE_EXTENSIONS
	required = 1,
#else
	required = 0,
#endif
};